"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const commands_1 = require("./commands");
exports.EAT_UP_KEY = '==-==';
class State {
    constructor() {
        this._inargumentMode = false;
        this._killRing = [];
    }
    updateAndGetKey(key) {
        if (key === 'C-g' && (this._inargumentMode || this._prefixKey)) {
            this.resetState();
            return exports.EAT_UP_KEY;
        }
        if (this.updateCuMode(key)) {
            return exports.EAT_UP_KEY;
        }
        if (!this._prefixKey) {
            if (commands_1.prefixPreservingKeys[key]) {
                this._prefixKey = key;
                return exports.EAT_UP_KEY;
            }
            return key;
        }
        else {
            return `${this._prefixKey} ${key}`;
        }
    }
    resetState(setLastInput = false) {
        this._inargumentMode = setLastInput;
        this._prefixKey = null;
        if (setLastInput) {
            this._lastInputBuffer = this._inputBuffer;
        }
        else {
            this._lastInputBuffer = null;
        }
        this._inputBuffer = null;
    }
    updateCuMode(key) {
        if (this._inargumentMode) {
            if (typeof key === 'string' && (/^\d$/.test(key))) {
                this._inputBuffer = (this._inputBuffer || '') + key;
                return true;
            }
            else if (commands_1.prefixPreservingKeys[key]) {
                this.resetState(true);
                return false;
            }
        }
        else if (!this._prefixKey && key === 'C-u') {
            this._inargumentMode = true;
            this._inputBuffer = null;
            this._lastInputBuffer = null;
            return true;
        }
    }
    updateStateOnExecution(reset = false) {
        this.resetState(reset);
    }
    getInputBuffer() {
        return this._lastInputBuffer || this._inputBuffer;
    }
    addToRing(str) {
        this._killRing.push(str);
        if (this._killRing.length > 50)
            this._killRing.shift();
    }
    growRingTop(str) {
        if (!this._killRing.length) {
            this.addToRing(str);
            this._killRing[this._killRing.length - 1] += str;
        }
    }
    getFromRing(n) {
        return this._killRing[this._killRing.length - (n ? Math.min(n, 1) : 1)] || '';
    }
    popFromRing() {
        if (this._killRing.length > 1) {
            return this._killRing.pop();
        }
        return this.getFromRing();
    }
    getReadableState() {
        let str = '';
        if (this._inargumentMode) {
            str += 'C-u';
            if (this._inputBuffer) {
                str += ` ${this._inputBuffer}`;
            }
            else if (this._lastInputBuffer) {
                str += ` ${this._lastInputBuffer}`;
            }
        }
        if (this._prefixKey) {
            str += ` ${this._prefixKey}`;
        }
        return str;
    }
}
exports.State = State;
